<?php
 //require_once '/../../../../setforms/v_100/applications/teknisa/objects/Tk/model/TkEvaluator.php';
/**
 * TeknisaEvaluator.
 *
 * @package Logic
 * @author  alessandrobartels / brunofeliciano - 12/08/2011
 */
class TeknisaEvaluator extends TkEvaluator{

    private $_teknisaRegra;


    /**
     * Construtor.
     *
     * @param TeknisaRegra $teknisa_regra Instancia de TeknisaRegra.
     *
     * @author alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function __construct(TeknisaRegra $teknisa_regra){
        parent::__construct();
        $this->_teknisaRegra = $teknisa_regra;
        /* $this->setObjectFunction(
         *  'VALOR_EVENTO', $this->_calculoRegra, 'retornaValorNumeroEvento', array('nr_evento')
         *  );
         */

        $this->_declaraVariaveis();
        $this->_declaraRegras();
    }


    /**
     * Determina as variaveis de regra.
     *
     * @return void
     *
     * @author alessandrobartels / brunofeliciano - 12/08/2011
     */
    private function _declaraVariaveis(){
        $this->setVar('CDOPERADOR', Ambiente::getCdOperador());
    }


    /**
     * Declara regras gerais.
     *
     * @return void
     *
     * @author alessandrobartels / brunofeliciano - 12/08/2011
     */
    private function _declaraRegras(){
        $this->setObjectFunction('VALOR_MAX', $this->_teknisaRegra, 'retornaMaiorValor', array('valor_1', 'valor_2'));
        $this->setObjectFunction('VALOR_MIN', $this->_teknisaRegra, 'retornaMenorValor', array('valor_1', 'valor_2'));
        $this->setObjectFunction(
            'COMPARA_VALOR', $this->_teknisaRegra, 'comparaValores',
            array(
                'valor_1', 'comparacao', 'valor_2',
            )
        );

        $this->setObjectFunction(
            'VALOR_ALEATORIO', $this->_teknisaRegra, 'retornaValorAleatorio',
            array(
                'limiteMin', 'limiteMax',
            )
        );

        $this->setObjectFunction('DATA_PARTE', $this->_teknisaRegra, 'retornaDataPorParte', array('data', 'tipo'));
        $this->setObjectFunction('DATA_DIFERENCA', $this->_teknisaRegra, 'retornaDiferencaDatas', array('data_1', 'data_2', 'tipo'));

    }


}