function Ger09700_ProjecaoDeEstoque_Controller(templateManager, ZhFilterPreferences, ScreenService, MessageService, ZhUtil, maskEngine) {
    
    this.openFilter = function(widget) {
    	ScreenService.showLoader();
        this.setFieldsGerais(widget);
        var rowsToSet = {};
		rowsToSet.defaultFilter = widget.dataSourceFilter;
		rowsToSet.REPORT_NAME = "GER09700";
		rowsToSet.DTLEV = {};
	    rowsToSet.DTLEV.formattedStart = moment().format('L');
        rowsToSet.DTLEV.formattedEnd = moment().format('L');
	    rowsToSet.DTLEV.start = moment().format('L');
        rowsToSet.DTLEV.end = moment().format('L');
        rowsToSet.TFILESTOQ = 'T';
		var widgetProjecao = templateManager.container.getWidget("widgetProjecao");
		widgetProjecao.getField("NMFILESTOQ").filterProperties.readOnly = true;
		widgetProjecao.getField("NMFILESTOQ").filterProperties.readOnlyOnEdit = true;
		delete widgetProjecao.getField("NMFILESTOQ").filterProperties.validations.required;
		delete widgetProjecao.getField("NMFILESTOQ").validations.required;
		rowsToSet.TFILIROM = 'T';
		widgetProjecao.getField("NMFILIROM").filterProperties.readOnly = true;
		widgetProjecao.getField("NMFILIROM").filterProperties.readOnlyOnEdit = true;
		delete widgetProjecao.getField("NMFILIROM").filterProperties.validations.required;
		delete widgetProjecao.getField("NMFILIROM").validations.required;
		rowsToSet.TSERIROM = 'T';
		widgetProjecao.getField("DSSERIE").filterProperties.readOnly = true;
		widgetProjecao.getField("DSSERIE").filterProperties.readOnlyOnEdit = true;
		delete widgetProjecao.getField("DSSERIE").filterProperties.validations.required;
		delete widgetProjecao.getField("DSSERIE").validations.required;
		widgetProjecao.getField("NMPRODINI").filterProperties.readOnly = false;
		widgetProjecao.getField("NMPRODINI").filterProperties.readOnlyOnEdit = false;
		widgetProjecao.getField("NMPRODINI").filterProperties.validations.required = true;
		widgetProjecao.getField("NMPRODINI").validations.required = true;
		delete widgetProjecao.getField("NMPRODFIN").filterProperties.validations.required;
		delete widgetProjecao.getField("NMPRODFIN").validations.required;
		rowsToSet.CDOPERADOR = getLocalVar('CDOPERADOR');
		
		ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
			var filtro = widget.container.getActiveWidget();
			this.filiProd(filtro);
			ScreenService.hideLoader();
		}).catch(error => {
			console.log(error);
			ScreenService.hideLoader();
		});
    };
    
    this.filiProd = function(widget) {
		var row = widget.currentRow;
		var filialIsSet = this.fieldIsSet(row.CDFILIAL);
		if (!filialIsSet) {
			widget.currentRow.NMPRODINI = '';
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.P_CDPRODINI = '';
			widget.currentRow.P_CDPRODFIN = '';
			delete widget.getField('NMPRODFIN').validations.required;
			widget.getField('NMPRODFIN').readOnly = true;
			widget.getField('NMPRODFIN').readOnlyOnEdit = true;
		} 
		if (row.NMFILIAL && (row.NMFILIAL != "")) {
			widget.getField('NMPRODINI').dataSourceFilter.forEach(function(fil) {
				if (fil.name === 'CDFILIAL') {
					fil.value = widget.currentRow.CDFILIAL;
				}
			});
			widget.getField('NMPRODFIN').dataSourceFilter.forEach(function(fil) {
				if (fil.name === 'CDFILIAL') {
					fil.value = widget.currentRow.CDFILIAL;
				}
			});
		}
		widget.getField('NMPRODINI').reload();
		widget.getField('NMPRODFIN').reload();
		widget.getField('NMPRODINI').readOnly = false;
		widget.getField('NMPRODINI').readOnlyOnEdit = false;
		widget.getField('NMPRODINI').reload();
		widget.getField('NMPRODFIN').reload();
	};

	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};
	
	this.changeFieldUnidadeEstoque = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.TFILESTOQ == 'T') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILESTOQ").readOnly = true;
					widget.getField("NMFILESTOQ").readOnlyOnEdit = true;
					delete widget.getField("NMFILESTOQ").validations.required;
					widget.currentRow.NMFILESTOQ = "";
					widget.currentRow.CDFILESTOQ = "";
					widget.getField("NMFILESTOQ").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else if(args.row.TFILESTOQ == 'L') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILESTOQ").readOnly = false;
					widget.getField("NMFILESTOQ").readOnlyOnEdit = false;
					widget.getField("NMFILESTOQ").validations.required = true;
					widget.getField("NMFILESTOQ").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};
	
	this.changeFieldUnidadeRomaneio = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.TFILIROM == 'T') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILIROM").readOnly = true;
					widget.getField("NMFILIROM").readOnlyOnEdit = true;
					delete widget.getField("NMFILIROM").validations.required;
					widget.currentRow.NMFILIROM = "";
					widget.currentRow.CDFILIROM = "";
					widget.getField("NMFILIROM").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else if(args.row.TFILIROM == 'L') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILIROM").readOnly = false;
					widget.getField("NMFILIROM").readOnlyOnEdit = false;
					widget.getField("NMFILIROM").validations.required = true;
					widget.getField("NMFILIROM").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};
	
	this.changeFieldSerieNF = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.TSERIROM == 'T') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("DSSERIE").readOnly = true;
					widget.getField("DSSERIE").readOnlyOnEdit = true;
					delete widget.getField("DSSERIE").validations.required;
					widget.currentRow.DSSERIE = "";
					widget.currentRow.CDSERIE = "";
					widget.getField("DSSERIE").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else if(args.row.TSERIROM == 'L') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("DSSERIE").readOnly = false;
					widget.getField("DSSERIE").readOnlyOnEdit = false;
					widget.getField("DSSERIE").validations.required = true;
					widget.getField("DSSERIE").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};
	
	this.fieldIsSet = function(fieldValue) {
		if (fieldValue) return true;
		else return false;
	};
	
	this.filterProdIni = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		if(!prodIniIsSet) {
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.CDPRODFIN = '';
			if(widget.name === "zhFilterPreferencesSelectConditions") {
                widget.getField('NMPRODFIN').readOnly = true;
                widget.getField('NMPRODFIN').readOnlyOnEdit = true;
                widget.getField('NMPRODFIN').clearValue();
			}
		} else if(widget.name === "zhFilterPreferencesSelectConditions") {
            widget.getField('NMPRODFIN').readOnly = false;
            widget.getField('NMPRODFIN').readOnlyOnEdit = false;
		}
        this.checkProductRange(args.owner.field);
	};
	
	this.filterProdFin = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodFinIsSet = this.fieldIsSet(row.CDPRODFIN);
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		
		if(!prodIniIsSet) {
            widget.getField('NMPRODFIN').readOnly = true;
            widget.getField('NMPRODFIN').readOnlyOnEdit = true;
            widget.getField('NMPRODFIN').clearValue();
            widget.getField('NMPRODFIN').reload();
		}
		
		this.checkProductRange(args.owner.field);
	};
	
	this.checkProductRange = function(field) {
	   var currentRow = field.widget.currentRow;

		if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
			var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

			if (!this.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {

                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL").then(success => {
					currentRow[field.outData[field.descriptionField]] = null;
					currentRow[field.outData[field.valueField]] = null;
					currentRow.CDPRODFIN = null;
                	field.widget.getField('NMPRODFIN').clearValue();
                	field.widget.getField('NMPRODFIN').reload();
                }).catch(error => {
                	console.log(error);
                });
			}
		}
	};
	
	this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
        var mask = {
          type: "fix",
          params: {
              mask: mascara
          }
        };
        pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
        pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
        var nvinicial = pinicial.length;
        var nvfinal = pfinal.length;
        var resultado = true;
        if(nvinicial != nvfinal) {
            if(nvinicial > nvfinal) {
                resultado = false;
            }
        } else {
            var i = 0;
            do {
                if(pinicial[i] > pfinal[i]) {
                    resultado = false;
                }
                i++;
            }
            while (i<pinicial.length && resultado);
        }
        return resultado;
    };
    
    this.changeBlockEstoque = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.CONSEST == 'N') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TFILESTOQ").readOnly = true;
					widget.getField("TFILESTOQ").readOnlyOnEdit = true;
					if(widget.getField("TFILESTOQ").value() == 'L') {
						widget.currentRow.TFILESTOQ = 'T';
						this.changeFieldUnidadeEstoque(args);
					}
					widget.getField("TFILESTOQ").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TFILESTOQ").readOnly = false;
					widget.getField("TFILESTOQ").readOnlyOnEdit = false;
					widget.getField("TFILESTOQ").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
    };
    
    this.changeBlockRomaneio = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.CONSROM == 'N') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TFILIROM").readOnly = true;
					widget.getField("TFILIROM").readOnlyOnEdit = true;
					if(widget.getField("TFILIROM").value() == 'L') {
						widget.currentRow.TFILIROM = 'T';
						this.changeFieldUnidadeRomaneio(args);
					}
					widget.getField("TFILIROM").reload();
					widget.getField("TSERIROM").readOnly = true;
					widget.getField("TSERIROM").readOnlyOnEdit = true;
					if(widget.getField("TSERIROM").value() == 'L') {
						widget.currentRow.TSERIROM = 'T';
						this.changeFieldSerieNF(args);
					}
					widget.getField("TSERIROM").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TFILIROM").readOnly = false;
					widget.getField("TFILIROM").readOnlyOnEdit = false;
					widget.getField("TFILIROM").reload();
					widget.getField("TSERIROM").readOnly = false;
					widget.getField("TSERIROM").readOnlyOnEdit = false;
					widget.getField("TSERIROM").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Ger09700_ProjecaoDeEstoque_Controller', Ger09700_ProjecaoDeEstoque_Controller);
});